// Serpiente con Clase
// (C) 2002 Con Clase http://www.conclase.net
// Salvador Pozo Coronado

// Implementacin de la clase para Laberinto:

#include <stdlib.h>
#include "laberint.h"

int random(int num);

CLaberinto::CLaberinto(CGraficos *gra) : Graficos(gra), 
   laberinto(NULL), nMuros(0)
{
   Iniciar(0);
}
 
void CLaberinto::Iniciar(int n)
{
   int y, x;
   int i;
   ifstream datos;
   char cad[20]; 
   char *szX, *szY;
   
   actual = n;
   if(laberinto) delete[] laberinto;
   
   wsprintf(cad, "%04d.lab", n);
   datos.open(cad); 
   for(x=0; x < ANCHO; x++)
      for(y = 0; y < ALTO; y++)
         tablero[x][y] = 0;
         
   libres = ANCHO*ALTO;
   datos.getline(cad, 20); // Nombre
   datos.getline(cad, 20); // Cuenta
   nMuros = atoi(cad);
   laberinto = new CCoordenada[nMuros];
   for(i = 0; i < nMuros; i++) {
      datos.getline(cad, 20);
      szX = strtok(cad, ",");
      szY = strtok(NULL, "\n");
      laberinto[i] = CCoordenada(atoi(szX), atoi(szY));
      tablero[atoi(szX)][atoi(szY)] = MURO;
      libres--;
   }
}

void CLaberinto::Mostrar(HDC dc)
{
   HDC memdc, dc2;

   for(int i = 0; i < nMuros; i++)
      Graficos->Mostrar(laberinto[i], MURO, dc);
   
   Graficos->MostrarFondo(CCoordenada(0, ALTO), dc);
}

bool CLaberinto::Colision(CCoordenada pos)
{
   return ((Tablero(pos) != LIMPIA) && (Tablero(pos) != COMIDA));
}

void CLaberinto::Modificar(CCoordenada pos, int valor)
{
   tablero[pos.X()][pos.Y()] = valor;
   if(valor) libres--; else libres++;
}

CCoordenada CLaberinto::ObtenerLibre()
{
   int v;
   CCoordenada pos(0,0);
   
   v = 1+random(libres);
 
   while(v > 0) {
      if(!Tablero(pos)) v--; 
      if(v) pos++;
   }
   return pos;
}

