// Plantilla para colas Con Clase
// (C) 2002 Con Clase http://www.conclase.net
// Salvador Pozo Coronado

template<class TIPO> class cola;

template<class TIPO>
class nodo {
   public:
    nodo(TIPO v, nodo<TIPO> *sig = NULL)
    {
       valor = v;
       siguiente = sig;
    }

   private:
    TIPO valor;
    nodo<TIPO> *siguiente;

   friend class cola<TIPO>;
};

template<class TIPO>
class cola {
   public:
    cola() : primero(NULL), ultimo(NULL), nelem(0) {}
    ~cola() {Vaciar();}

    void Anadir(TIPO v);
    TIPO Leer();
    void Vaciar();
    bool Consultar(TIPO &v);
    bool Siguiente(TIPO &v);
    TIPO &ObtenerUltimo();
    TIPO &ObtenerPrimero();
    
    int nelem;
   private:
    nodo<TIPO>* primero;
    nodo<TIPO>* ultimo;
    nodo<TIPO>* actual;
};

template<class TIPO>
void cola<TIPO>::Vaciar()
{
   while(primero) Leer();
}

template<class TIPO>
void cola<TIPO>::Anadir(TIPO v)
{
   nodo<TIPO> *nuevo;

   /* Crear un nodo nuevo */
   /* Este ser el ltimo nodo, no debe tener siguiente */
   nuevo = new nodo<TIPO>(v);
   /* Si la cola no estaba vaca, aadimos el nuevo a continuacin de ultimo */
   if(ultimo) ultimo->siguiente = nuevo;
   /* Ahora, el ltimo elemento de la cola es el nuevo nodo */
   ultimo = nuevo;
   /* Si primero es NULL, la cola estaba vaca, ahora primero apuntar tambin al nuevo nodo */
   if(!primero) primero = nuevo;
   nelem++;
}

template<class TIPO>
TIPO cola<TIPO>::Leer()
{
   nodo<TIPO> *Nodo; /* variable auxiliar para manipular nodo */
   TIPO v;      /* variable auxiliar para retorno */

   /* Nodo apunta al primer elemento de la pila */
   Nodo = primero;
   if(!Nodo) return 0; /* Si no hay nodos en la pila retornamos 0 */
   /* Asignamos a primero la direccin del segundo nodo */
   primero = Nodo->siguiente;
   /* Guardamos el valor de retorno */
   v = Nodo->valor;
   /* Borrar el nodo */
   delete Nodo;
   /* Si la cola qued vaca, ultimo debe ser NULL tambin*/
   if(!primero) ultimo = NULL;
   nelem--;
   return v;
}

template<class TIPO>
bool cola<TIPO>::Consultar(TIPO &v)
{
   actual = primero;
   if(!actual) return false;
   v = actual->valor;
   return true;
}

template<class TIPO>
bool cola<TIPO>::Siguiente(TIPO &v)
{
   actual = actual->siguiente;
   if(!actual) return false;
   v = actual->valor;
   return true;
}

template<class TIPO>
TIPO &cola<TIPO>::ObtenerUltimo()
{
   return ultimo->valor;
}

template<class TIPO>
TIPO &cola<TIPO>::ObtenerPrimero()
{
   return primero->valor;
}

