// Serpiente con Clase
// (C) 2002 Con Clase http://www.conclase.net
// Salvador Pozo Coronado

// Implementacin de la clase para CGraficos:

#include "graficos.h"

CGraficos::CGraficos(HINSTANCE hinst, HWND hw) : 
   hInstance(hinst), hwnd(hw)
{
   bmp = LoadBitmap(hInstance, MAKEINTRESOURCE(GRAFICOS));
   extras = LoadBitmap(hInstance, MAKEINTRESOURCE(EXTRAS));
   num = LoadBitmap(hInstance, MAKEINTRESOURCE(NUMERO));
   marcador= LoadBitmap(hInstance, MAKEINTRESOURCE(MARCADOR));
}

CGraficos::~CGraficos() 
{
   FreeResource(bmp);
   FreeResource(extras);
   FreeResource(num);
   FreeResource(marcador);
}

void CGraficos::Mostrar(CCoordenada coor, int tipo, HDC dc)
{
   HDC memdc, dc2;
   
   if(!dc) dc2 = GetDC(hwnd); else dc2 = dc;
   memdc = CreateCompatibleDC(dc2);
   SelectObject(memdc, bmp);
   BitBlt(dc2, 16*coor.X(), 16*coor.Y(), 16, 16, memdc, 16*tipo, 0, SRCCOPY);
   DeleteDC(memdc);
   if(!dc) ReleaseDC(hwnd, dc2);
}

void CGraficos::MostrarExtra(CCoordenada coor, int tipo, int estado, HDC dc)
{
   HDC memdc, dc2;
   
   if(!dc) dc2 = GetDC(hwnd); else dc2 = dc;
   memdc = CreateCompatibleDC(dc2);
   SelectObject(memdc, extras);
   BitBlt(dc2, 16*coor.X(), 16*coor.Y(), 16, 16, memdc, 16*(estado>>2), 16*tipo, SRCCOPY);
   DeleteDC(memdc);
   if(!dc) ReleaseDC(hwnd, dc2);
}

void CGraficos::MostrarFondo(CCoordenada coor, HDC dc)
{
   HDC memdc, dc2;
   
   if(!dc) dc2 = GetDC(hwnd); else dc2 = dc;
   memdc = CreateCompatibleDC(dc2);
   SelectObject(memdc, marcador);
   BitBlt(dc2, 16*coor.X(), 16*coor.Y(), 512, 32, memdc, 0, 0, SRCCOPY);
   DeleteDC(memdc);
   if(!dc) ReleaseDC(hwnd, dc2);
}

void CGraficos::Texto(CCoordenada coor, int v, HDC dc)
{
   HDC memdc, dc2;
   char cad[7];
   int i;
 
   wsprintf(cad, "%05d", v);
   if(!dc) dc2 = GetDC(hwnd); else dc2 = dc;
   memdc = CreateCompatibleDC(dc2);

   SelectObject(memdc, num);
   for(i = 0; i < 5; i++)
      BitBlt(dc2, 16*(i+coor.X()), 16*coor.Y(), 16, 16, memdc, 16*(cad[i]-'0'), 0, SRCCOPY);
   
   DeleteDC(memdc);
   if(!dc) ReleaseDC(hwnd, dc2);
}

void CGraficos::Borrar()
{
   RECT cliente;

   GetClientRect(hwnd, &cliente);
   InvalidateRect(hwnd, &cliente, TRUE);
}

