// Serpiente con Clase
// (C) 2002 Con Clase http://www.conclase.net
// Salvador Pozo Coronado

// Declaracin de clase "CJuego":

#include <windows.h>
#include <stdlib.h>
#include "coordena.h"
#include "direccio.h"
#include "extra.h"
#include "graficos.h"
#include "laberint.h"
#include "serpient.h"
#include "tanteo.h"

#ifndef CL_JUEGO
#define CL_JUEGO

class CJuego {
  public:
   CJuego(HWND, HINSTANCE);
   ~CJuego();
   // Funciones auxiliares:
   void LeerMenu(HWND);
   void LeerRegistro();
   void GuardarRegistro();
   void Mostrar(HDC);
   void CambiaLaberinto(int);
   void CambiaVelocidad(int);
   void ActivarMenus(bool);
   void Movimiento();
   const int Velocidad() {return velocidad;}
   void Empezar();
   const bool Parado() {return pausa;}
   void MoverSerpiente(eDireccion);

  private:
   // Variables y objetos globales:
   CSerpiente *Serpiente;
   CGraficos *Graficos;
   CLaberinto *Laberinto;
   CTanteo *Tanteo;
   CComida *Comida;
   CExtra *Extra;
   
   bool pausa;
   int nLaberintos;
   HWND hwnd;

   // Datos que se almacenan en el registro:
   int laberinto;
   int velocidad;
   int *puntuacion;
};
#endif

