// Serpiente con Clase
// (C) 2002 Con Clase http://www.conclase.net
// Salvador Pozo Coronado

// Declaracin de clase "CSeccion":

#include <windows.h>
#include "coordena.h"

#ifndef CL_SECCION
#define CL_SECCION

// Clase para secciones:
class CSeccion {
  public:
   // Constructores:
   CSeccion() : posicion(0,0), tipo(0) {}
   CSeccion(const CSeccion &sec) : 
      posicion(sec.posicion), tipo(sec.tipo) {}
   CSeccion(const CCoordenada &coor, int t) : 
      posicion(coor), tipo(t) {};
   CSeccion(int x, int y, int t) : 
      posicion(x,y), tipo(t) {};
   CSeccion(int v) : posicion(0,0), tipo(v) {};
   
   void ModificarTipo(int t) {tipo=t;}
   const CCoordenada Posicion() {return posicion;}
   const int Tipo() {return tipo;}
   CSeccion &operator=(const CSeccion &sec)
      {posicion = sec.posicion; tipo = sec.tipo; return *this;}
   
  private:
   CCoordenada posicion;
   int tipo;
};
#endif

